swagger: "2.0"
info:
  description: "An api for getting users and hobbies"
  version: "1.0.0"
  title: "Arive"
  contact:
    email: "omar.shrbajy1@gmail.com"
  license:
host: "localhost:4000"
basePath: "/api"
tags:
  - name: "user"
    description: "Operations about user"
    externalDocs:
      description: "Find out more about our store"
      url: "http://swagger.io"
  - name: "hobby"
    description: "Operations about hobby"
    externalDocs:
      description: "Find out more about our store"
      url: "http://swagger.io"
schemes:
  - "http"
paths:
  /users:
    get:
      tags:
        - "user"
      summary: "Add a new pet to the store"
      description: ""
      operationId: "getUsers"
      consumes:
        - "application/json"
      produces:
        - "application/json"
      responses:
        "200":
          description: "users"
          schema:
            type: "array"
            items:
              $ref: "#/definitions/User"
    post:
      tags:
        - "user"
      summary: "Create new user"
      description: ""
      operationId: "createUser"
      consumes:
        - "application/json"
      produces:
        - "application/json"
      parameters:
        - in: "body"
          name: "body"
          description: "create a new user"
          required: true
          schema:
            $ref: "#/definitions/User"
      responses:
        "400":
          description: "Validation error"
        "200":
          description: "user  object"
          schema:
            $ref: "#/definitions/User"

  /hobbies:
    get:
      tags:
        - "hobby"
      summary: "Get hobbies by user id"
      description: "get hobbies by user id"
      operationId: "getHobbies"
      produces:
        - "application/json"
      parameters:
        - name: "userId"
          in: "query"
          description: "userId value"
          required: false
          type: "string"
      responses:
        "200":
          description: "successful operation"
          schema:
            type: "array"
            items:
              $ref: "#/definitions/Hobby"
        "400":
          description: "invalid_id"
    post:
      tags:
        - "hobby"
      summary: "Create new user"
      description: ""
      operationId: "createUser"
      consumes:
        - "application/json"
      produces:
        - "application/json"
      parameters:
        - in: "body"
          name: "body"
          description: "create a new user"
          required: true
          schema:
            $ref: "#/definitions/Hobby"
      responses:
        "400":
          description: "Validation_error - invalid_id"
        "200":
          description: "user  object"
          schema:
            $ref: "#/definitions/User"
  /hobbies/{hobbyId}:
    delete:
      tags:
        - "hobby"
      summary: "Deletes a hobby"
      description: ""
      operationId: "deleteHobby"
      produces:
        - "application/json"
      parameters:
        - name: "hobbyId"
          in: "path"
          description: "hobby id to delete"
          required: true
          type: "string"
      responses:
        "400":
          description: "Invalid ID supplied"
definitions:
  User:
    type: "object"
    properties:
      _id:
        type: "string"
      name:
        type: "string"
  Hobby:
    type: "object"
    properties:
      _id:
        type: "string"
      name:
        type: "string"
      year:
        type: "number"
      userId:
        type: "string"
      passionLevel:
        type: "string"
        enum:
          - "low"
          - "high"
          - "medium"
          - "veryHigh"
externalDocs:
  description: "Find out more about Swagger"
  url: "http://swagger.io"